varying vec3 EyeDir;
varying vec3 LightDir;

uniform sampler2D Texture;
uniform sampler2D NormalMap;

void main()
{
   	vec2 TexCoords = gl_TexCoord[0].st;

	vec3 fragView = normalize(EyeDir);
	vec3 fragLight = normalize(LightDir);
	
	vec4 base = texture2D(Texture, gl_TexCoord[0].xy);
	vec3 bump = texture2D(NormalMap, gl_TexCoord[0].xy).xyz * 2.0 - 1.0;
	
	bump = normalize(bump);

	/*float diffuse = float((clamp(dot(lVec, bump),0.0,1.0)));

	float specular = pow(clamp(dot(reflect(-vVec, bump), lVec),0.0,1.0),gl_FrontMaterial.shininess);

	gl_FragColor = gl_FrontLightModelProduct.sceneColor + ((((diffuse * gl_FrontLightProduct[0].diffuse)+ gl_FrontLightProduct[0].ambient) * base)+ (gl_FrontLightProduct[0].specular * specular));
	*/

	
	float NdotL = max(0.0, dot(bump, fragLight));
	
	vec3 reflection = normalize(reflect(fragLight, bump));
	
	float VdotR = dot(fragView, reflection);
	float VdotRExp = pow(max(0.0, VdotR), gl_FrontMaterial.shininess);

	vec4 color = gl_FrontLightModelProduct.sceneColor
				+ gl_FrontLightProduct[0].ambient
				+ gl_FrontLightProduct[0].diffuse * NdotL
				+ gl_FrontLightProduct[0].specular * VdotRExp;

	gl_FragColor = color * texture2D(Texture, gl_TexCoord[0].xy);
}